<template lang="pug">
  q-list(bordered, separator)
    q-item(v-for="(submissions, sensorName) in breakoutRoomSubmissions")
      q-expansion-item(
        group="breakout-rooms"
        :label="`${sensorName} chat submissions: ${submissions.length}`"
      )
        q-list(bordered, separator)
          q-item(v-for="submission of submissions")
            q-item-section {{ submission.submission }} (from: {{ submission.senderName }})
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import {
  ZoomSenseClientFirebaseDB,
  ZoomSenseMeetingChatNode,
} from "@zoomsense/zoomsense-firebase";
import { Config, Submission } from "@zoomsense/chat-submission-types";

export default Vue.extend({
  name: "Dashboard",
  props: {
    firebase: {
      required: true,
      type: Object as PropType<ZoomSenseClientFirebaseDB>,
    },
    context: {
      required: true,
      type: Object as PropType<{ meetingId: string }>,
    },
  },
  data() {
    return {
      chats: null as null | { [sensorName: string]: ZoomSenseMeetingChatNode },
      chatSubmission: null as null | { [submissionId: string]: Submission },
      pluginConfig: null as null | Config,
    };
  },
  computed: {
    breakoutRoomSubmissions(): { [sensorName: string]: Submission[] } {
      const { chats, pluginConfig, chatSubmission } = this;
      if (!chats || !pluginConfig?.enabled) {
        return {};
      }
      const result: { [sensorName: string]: Submission[] } = Object.fromEntries(
        Object.keys(chats)
          .filter(
            (sensorName) =>
              sensorName === "ZoomSensor_1" || chats[sensorName].isInBO
          )
          .map((sensorName) => [sensorName, []])
      );
      if (chatSubmission) {
        for (const submission of Object.values(chatSubmission)) {
          if (pluginConfig.submissions?.find(
            (config) => config.name === submission.submissionName
          )) {
            if (!result[submission.sensor]) {
              result[submission.sensor] = [submission];
            } else {
              result[submission.sensor].push(submission);
            }
          }
        }
      }
      return result;
    },
  },
  async created() {
    await Promise.all([
      this.$typedRtdbBind(
        "chats",
        this.firebase.ref(`data/chats/${this.context.meetingId}`)
      ),
      this.$typedRtdbBind(
        "pluginConfig",
        this.firebase.ref(
          `config/${this.context.meetingId}/current/currentState/plugins/chatsubmission`
        )
      ),
      this.$typedRtdbBind(
        "chatSubmission",
        this.firebase.ref(
          `data/plugins/chatSubmission/${this.context.meetingId}`
        )
      ),
    ]);
  },
});
</script>
